Subject: [Teas] question on the topology filter draft

From: Loa Andersson <[email-masked]>
Date: Tue, 9 Nov 2021 18:57:40 +0100

WG, Pavan, authors,

I was cut off at the end of the queue in the wg discussion. I had a 
fairly simple question,

Where the topology filter(s) defined and what benefits do we get from 
using them?

/Loa
-- 

Loa Andersson                        email: [email-masked]
Senior MPLS Expert                          [email-masked]
Bronze Dragon Consulting             phone: +46 739 81 21 64

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Wed, 10 Nov 2021 06:23:26 -0600

Loa,

Please see inline (prefixed VPB)

Regards,
-Pavan

On Tue, Nov 9, 2021 at 11:57 AM Loa Andersson <[email-masked]> wrote:

> Where the topology filter(s) defined

[VPB] The term “topology filter” is being introduced in
draft-bestbar-teas-yang-topology-filter (not aware of any other document
where it is defined). As per this data model draft, a “topology filter” is
a data construct that can be applied on either a native topology or a
customized topology to produce a filtered set of topological elements. The
native or customized topology referred to here is a TE aware topology
[RFC8795].

and what benefits do we get from
> using them?

[VPB] There are a couple of use-cases that are being targeted with this
construct.

(a) Specification of topology related constraints for TE path computation
(any setup type):
A few examples:
- Compute a path within a specific topology
- Compute a path within the topology associated with a specific IGP domain
- Compute a path within the topology learnt from a specific TE Information
Source
- Compute a path within the topology defined by the application of one or
more topology-filters
** Say, a topology with elements that are learnt via ISIS Level-2 and
include resource-affinity red
** Or, a topology with elements associated with ISIS Flex-Algo 128 and do
not include resource-affinity blue

(b) Specification of filter-topology associated with a Network Resource
Partition

> _______________________________________________
> Teas mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/teas
>

---

From: Loa Andersson <[email-masked]>
Date: Wed, 10 Nov 2021 15:28:28 +0100

Pavan,

This mail gives me more (and useful) inforamtion than the draft did, 
e.g. that topology filters are a new concept. And where to find related 
info, would you consider adding it in some for to the draft.

/Loa

On 10/11/2021 13:23, Vishnu Pavan Beeram wrote:
> On Tue, Nov 9, 2021 at 11:57 AM Loa Andersson <[email-masked] 
> <mailto:[email-masked]>> wrote:
> 
>     WG, Pavan, authors,
> 
> where it is defined). As per this data model draft, a “topology filter” 
> is a data construct that can be applied on either a native topology or a 
> customized topology to produce a filtered set of topological 
> elements. The native or customized topology referred to here is a TE 
> aware topology [RFC8795].
> 
> (a) Specification of topology related constraints for TE path 
> computation (any setup type):
> A few examples:
> - Compute a path within the topology learnt from a specific TE 
> Information Source
> - Compute a path within the topology defined by the application of one 
> or more topology-filters
> ** Or, a topology with elements associated with ISIS Flex-Algo 128 and 
> do not include resource-affinity blue
> 
>     Loa Andersson                        email: [email-masked] <mailto:[email-masked]>
>     Senior MPLS Expert [email-masked] <mailto:[email-masked]>
>     [email-masked] <mailto:[email-masked]>
>     <https://www.ietf.org/mailman/listinfo/teas>
> 

--

---

From: John E Drake <[email-masked]>
Date: Wed, 10 Nov 2021 14:33:02 +0000

Hi,

Comment inline

Yours Irrespectively,

John

Juniper Business Use Only
From: Teas <[email-masked]> On Behalf Of Vishnu Pavan Beeram
Sent: Wednesday, November 10, 2021 7:23 AM
To: Loa Andersson <[email-masked]>
Cc: TEAS WG <[email-masked]>
Subject: Re: [Teas] question on the topology filter draft

[External Email. Be cautious of content]

Loa,

Regards,
-Pavan

On Tue, Nov 9, 2021 at 11:57 AM Loa Andersson <[email-masked]<mailto:[email-masked]>> wrote:
WG, Pavan, authors,

[VPB] The term "topology filter" is being introduced in draft-bestbar-teas-yang-topology-filter (not aware of any other document where it is defined). As per this data model draft, a "topology filter" is a data construct that can be applied on either a native topology or a customized topology to produce a filtered set of topological elements. The native or customized topology referred to here is a TE aware topology [RFC8795].

[JD]   https://datatracker.ietf.org/doc/html/draft-drake-bess-enhanced-vpn-06

[VPB] There are a couple of use-cases that are being targeted with this construct.

(a) Specification of topology related constraints for TE path computation (any setup type):
A few examples:
- Compute a path within a specific topology
- Compute a path within the topology associated with a specific IGP domain
- Compute a path within the topology learnt from a specific TE Information Source
- Compute a path within the topology defined by the application of one or more topology-filters
** Say, a topology with elements that are learnt via ISIS Level-2 and include resource-affinity red
** Or, a topology with elements associated with ISIS Flex-Algo 128 and do not include resource-affinity blue

(b) Specification of filter-topology associated with a Network Resource Partition

/Loa
--

Loa Andersson                        email: [email-masked]<mailto:[email-masked]>
Senior MPLS Expert                          [email-masked]<mailto:[email-masked]>
Bronze Dragon Consulting             phone: +46 739 81 21 64

_______________________________________________
Teas mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/teas<https://urldefense.com/v3/__https:/www.ietf.org/mailman/listinfo/teas__;!!NEt6yMaO-gk!Wwe6TIhceoDY185rYv6hW53oI4RFifTJm-vZv_t6bYtBA-nipiM9UqKD8Acvqmw$>

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Wed, 10 Nov 2021 08:38:45 -0600

Loa, Hi!

Point taken. The next revision should provide a better narrative.

Regards,
-Pavan (on behalf of the authors)

---

From: "Dongjie (Jimmy)" <[email-masked]>
Date: Thu, 11 Nov 2021 18:11:00 +0000

Hi Pavan,

Please fine some comments about topology filter and its usage inline:

From: Teas [mailto:[email-masked]] On Behalf Of Vishnu Pavan Beeram
Sent: Wednesday, November 10, 2021 8:23 PM
To: Loa Andersson <[email-masked]>
Cc: TEAS WG <[email-masked]>
Subject: Re: [Teas] question on the topology filter draft

Loa,

Regards,
-Pavan

[VPB] The term “topology filter” is being introduced in draft-bestbar-teas-yang-topology-filter (not aware of any other document where it is defined). As per this data model draft, a “topology filter” is a data construct that can be applied on either a native topology or a customized topology to produce a filtered set of topological elements. The native or customized topology referred to here is a TE aware topology [RFC8795].

[Jie] Since the term “topology filter” is newly introduced in this YANG model draft, it would be useful to state in the document “who” is the consumer of this information. More specifically, who will use the topology filter in path or route computation.

[Jie]  In the last case, why use Flex-Algo with an additional rule of include-affinity blue? The include rule can be defined as part of the Flex-Algo.

And what does “resource-affinity” mean in a topology filter?

[Jie] Topology-filter and filter-topology sounds confusing to me. How about simply say “specification of the topology associated with a Network Resource Partition”?

Best regards,
Jie

/Loa
--

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Fri, 12 Nov 2021 00:24:08 -0600

Jie,

Please see inline [prefixed Pavan]

Regards,
-Pavan

On Thu, Nov 11, 2021 at 12:11 PM Dongjie (Jimmy) <[email-masked]>
wrote:

> *From:* Teas [mailto:[email-masked]] *On Behalf Of *Vishnu Pavan
> Beeram
> *Sent:* Wednesday, November 10, 2021 8:23 PM
> *To:* Loa Andersson <[email-masked]>
> *Cc:* TEAS WG <[email-masked]>
> *Subject:* Re: [Teas] question on the topology filter draft
>
>
>
> Loa,
>
>
>
> [Jie] Since the term “topology filter” is newly introduced in this YANG
> model draft, it would be useful to state in the document “who” is the
> consumer of this information. More specifically, who will use the topology
> filter in path or route computation.
>
>
>

[Pavan] The consumer depends on the use-case; The to-be-added use-case
section is expected to  have sufficient details to address this.

> [Jie]  In the last case, why use Flex-Algo with an additional rule of
> include-affinity blue? The include rule can be defined as part of the
> Flex-Algo.
>
>
[Pavan] Good question (was expecting someone to ask this; brownie points
are in order)! Yes, you could always place as many constraints as you want
in your Flex-Algo definition (FAD). But we are talking about TE path
computation profiles here -- the number of TE path computation profiles
used in a network need not be "limited" by the number of FADs deployed in
it. When a Flex-Algo ID is passed in as part of the computation profile of
an SR path to a path compute engine, an implementation may merge the
constraints in the associated FAD with "other" specified constraints and
then come up with an appropriate path (the SIDs of the Flex-Algorithm are
used where applicable to compress the resultant path).

> And what does “resource-affinity” mean in a topology filter?

Resource Affinity == Admin group ([RFC3630
<https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc3630__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb6z3fYS2$>],
[RFC5329
<https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc5329__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb9gfGNqM$>],
[RFC5305
<https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc5305__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb33V9PD-$>]
and [RFC7308
<https://urldefense.com/v3/__https://datatracker.ietf.org/doc/html/rfc7308__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb01y_A-E$>
]).

> [Jie] Topology-filter and filter-topology sounds confusing to me. How
> about simply say “specification of the topology associated with a Network
> Resource Partition”?
>
>
>

[Pavan] Ok. I was specifying a use-case using a term that is currently
specified in draft-ietf-teas-ietf-network-slices-05; We will address
terminology policing comments (if any) after the use-case section is
published in the draft.

---

From: "Dongjie (Jimmy)" <[email-masked]>
Date: Mon, 22 Nov 2021 11:45:49 +0000

Hi Pavan,

Thanks for your reply. Please see some further inline with [Jie #2].

From: Vishnu Pavan Beeram [mailto:[email-masked]]
Sent: Friday, November 12, 2021 2:24 PM
To: Dongjie (Jimmy) <[email-masked]>
Cc: Loa Andersson <[email-masked]>; TEAS WG <[email-masked]>
Subject: Re: [Teas] question on the topology filter draft

Jie,

Regards,
-Pavan

On Thu, Nov 11, 2021 at 12:11 PM Dongjie (Jimmy) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Pavan,

From: Teas [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Vishnu Pavan Beeram
Sent: Wednesday, November 10, 2021 8:23 PM
To: Loa Andersson <[email-masked]<mailto:[email-masked]>>
Cc: TEAS WG <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Teas] question on the topology filter draft

Loa,

Regards,
-Pavan

[Pavan] The consumer depends on the use-case; The to-be-added use-case section is expected to  have sufficient details to address this.

[Jie #2] OK, would like to review the use case section when it is available.
and what benefits do we get from
using them?

[Pavan] Good question (was expecting someone to ask this; brownie points are in order)! Yes, you could always place as many constraints as you want in your Flex-Algo definition (FAD). But we are talking about TE path computation profiles here -- the number of TE path computation profiles used in a network need not be "limited" by the number of FADs deployed in it. When a Flex-Algo ID is passed in as part of the computation profile of an SR path to a path compute engine, an implementation may merge the constraints in the associated FAD with "other" specified constraints and then come up with an appropriate path (the SIDs of the Flex-Algorithm are used where applicable to compress the resultant path).

[Jie #2] Thanks for your explanation. My understanding is FAD is defined for the network nodes to perform constraint based path computation in a distributed manner. While the merge of constraints in FAD and “other” specified constraints can only be used for centralized TE path computation, as the merged constraints cannot be used for distributed computation by the network nodes which only take the constraints in FAD in consideration of the computation, this means the computed TE path can only be a strict explicit path. Is my understanding correct? IMO this loses the major benefit of the Flex-Algo mechanism and does not need to be based on Flex-Algo.

Resource Affinity == Admin group ([RFC3630<https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc3630__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb6z3fYS2$>], [RFC5329<https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc5329__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb9gfGNqM$>], [RFC5305<https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc5305__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb33V9PD-$>] and [RFC7308<https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc7308__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb01y_A-E$>]).

[Jie #2] Understood, in this case Admin group maybe be a better term.

[Pavan] Ok. I was specifying a use-case using a term that is currently specified in draft-ietf-teas-ietf-network-slices-05; We will address terminology policing comments (if any) after the use-case section is published in the draft.

[Jie #2] OK, and agree that terminology policing and alignment is needed.

Best regards,
Jie

Best regards,
Jie

/Loa
--

---

From: Igor Bryskin <[email-masked]>
Date: Mon, 22 Nov 2021 15:01:29 +0000 (UTC)

Hi Pavan and Tarek,
I have also a simple question: what is the difference between topology filters and a sets of path computation constraints? In the TE tunnel model we have defined the Named Path Constraint object that could be applied to a range of path computations. Sounds to me like a very close cousin that could be easily adopted/tuned to your use cases.
Cheers,Igor

Sent from Yahoo Mail on Android 
 
  On Mon, Nov 22, 2021 at 6:46 AM, Dongjie (Jimmy)<jie.dong=[email-masked]> wrote:   _______________________________________________
Teas mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/teas

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Mon, 22 Nov 2021 10:57:21 -0600

Jie, Hi!

Please see inline (prefixed - [Vishnu Pavan])

Regards,
-Pavan

On Mon, Nov 22, 2021 at 5:45 AM Dongjie (Jimmy) <[email-masked]> wrote:

> *From:* Vishnu Pavan Beeram [mailto:[email-masked]]
> *Sent:* Friday, November 12, 2021 2:24 PM
> *To:* Dongjie (Jimmy) <[email-masked]>
> *Cc:* Loa Andersson <[email-masked]>; TEAS WG <[email-masked]>
> [Jie #2] Thanks for your explanation. My understanding is FAD is defined
> for the network nodes to perform constraint based path computation in a
> distributed manner. While the merge of constraints in FAD and “other”
> specified constraints can only be used for centralized TE path computation,
> as the merged constraints cannot be used for distributed computation by the
> network nodes which only take the constraints in FAD in consideration of
> the computation, this means the computed TE path can only be a strict
> explicit path. Is my understanding correct? IMO this loses the major
> benefit of the Flex-Algo mechanism and does not need to be based on
> Flex-Algo.
>
>
[Vishnu Pavan] For the path computation use-case example above, please
consider a TE path computation profile associated with an SR policy (this
is not to be confused with IGP computation). The SR policy TE
path-computation application may be centralized or distributed (the
topology-filter in question just needs to be available at the computing
node/element).

> <https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc3630__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb6z3fYS2$>],
> [RFC5329
> <https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc5329__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb9gfGNqM$>],
> [RFC5305
> <https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc5305__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb33V9PD-$>]
> and [RFC7308
> <https://urldefense.com/v3/__https:/datatracker.ietf.org/doc/html/rfc7308__;!!NEt6yMaO-gk!Wf63bNr9BsYF3NyuMHU51LlImOftv9m46EjW6Sl_v-ePYK0WjHXlEnRjb01y_A-E$>
> ]).
>
>
>

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Mon, 22 Nov 2021 11:40:51 -0600

Igor, Hi!

Yes, the "named path constraints" object as defined today includes some
topology filtering constraints for the path. But, as you know, it includes
various other path specific constraints as well.

A named path constraint object may reference a topology-filter if available.

Regards,
-Pavan

On Mon, Nov 22, 2021 at 9:01 AM Igor Bryskin <[email-masked]> wrote:

> Hi Pavan and Tarek,
>
> I have also a simple question: what is the difference between topology
> filters and a sets of path computation constraints? In the TE tunnel model
> we have defined the Named Path Constraint object that could be applied to a
> range of path computations. Sounds to me like a very close cousin that
> could be easily adopted/tuned to your use cases.
>
> Cheers,
> Igor
>
> <https://go.onelink.me/107872968?pid=InProduct&c=Global_Internal_YGrowth_AndroidEmailSig__AndroidUsers&af_wl=ym&af_sub1=Internal&af_sub2=Global_YGrowth&af_sub3=EmailSignature>
>
> On Mon, Nov 22, 2021 at 6:46 AM, Dongjie (Jimmy)
> <jie.dong=[email-masked]> wrote:

---

From: Tarek Saad <[email-masked]>
Date: Mon, 22 Nov 2021 17:55:09 +0000

Hi Igor,

Topology filters can be used to create a ‘custom’ topology – such that it can be referenced from within “named path constraints” as Pavan mentioned. Additional constraints can also be imposed (per path) using the “named path constraints” to restrict the path within the ‘custom’ topology.

Regards,
Tarek

From: Teas <[email-masked]> on behalf of Vishnu Pavan Beeram <[email-masked]>
Date: Monday, November 22, 2021 at 12:41 PM
To: Igor Bryskin <[email-masked]>
Cc: TEAS WG <[email-masked]>, "Dongjie (Jimmy)" <jie.dong=[email-masked]>, Loa Andersson <[email-masked]>
Subject: Re: [Teas] question on the topology filter draft

Igor, Hi!

Yes, the "named path constraints" object as defined today includes some topology filtering constraints for the path. But, as you know, it includes various other path specific constraints as well.

Regards,
-Pavan

On Mon, Nov 22, 2021 at 9:01 AM Igor Bryskin <[email-masked]<mailto:[email-masked]>> wrote:
Hi Pavan and Tarek,

Cheers,
Igor
Sent from Yahoo Mail on Android<https://go.onelink.me/107872968?pid=InProduct&c=Global_Internal_YGrowth_AndroidEmailSig__AndroidUsers&af_wl=ym&af_sub1=Internal&af_sub2=Global_YGrowth&af_sub3=EmailSignature>

<jie.dong=[email-masked]<mailto:[email-masked]>> wrote:

---

From: Igor Bryskin <[email-masked]>
Date: Mon, 22 Nov 2021 18:38:19 +0000 (UTC)

Tarek,
What do you need  a filtered topology for other than constrained path computations?
What is the difference between path computation on a filtered topology and one on  an unfiltered topology with filters as constraints?
Why additional path level constraints defined in the Named Path Constraints object is an inconvenience for you, guys?  Surely you would need, say, delay constrained computations performed on filtered topologies, right?
Igor

  On Mon, Nov 22, 2021 at 12:55 PM, Tarek Saad<[email-masked]> wrote:   _______________________________________________
Teas mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/teas

---

From: Vishnu Pavan Beeram <[email-masked]>
Date: Mon, 22 Nov 2021 19:43:19 -0600

Igor, Hi!

Please see inline (prefixed [Vishnu])

Regards,
-Pavan

> What do you need  a filtered topology for other than constrained path

[Vishnu] As noted earlier in the thread, the topology-filter construct can
be used in the specification of the filtered topology associated with a
Network Resource Partition. This same construct, if supported by an
implementation, may also be used in the specification of the topology
filtering constraints for path computation.

>
> What is the difference between path computation on a filtered topology and
> one on  an unfiltered topology with filters as constraints?
>

[Vishnu] Either works. It is an implementation/deployment choice and (imho)
the toolkit should allow for both options to exist.

>
> Why additional path level constraints defined in the Named Path
> Constraints object is an inconvenience for you, guys?  Surely you would
> need, say, delay constrained computations performed on filtered topologies,
> right?
>

> On Mon, Nov 22, 2021 at 12:55 PM, Tarek Saad
> <[email-masked]> wrote:

---

From: Igor Bryskin <[email-masked]>
Date: Tue, 23 Nov 2021 14:55:03 +0000 (UTC)

Thanks Pavan,
Jus wanted to clarify. When you say "the topology-filter construct can be used in the specification of the filtered topology associated with a Network Resource Partition", who [which controller] is making the specification and to whom,  how such specification is supposed to be utilized and why it needs to be standardized?

Igor

    On Monday, November 22, 2021, 08:43:46 PM EST, Vishnu Pavan Beeram <[email-masked]> wrote:  
 
 Igor, Hi!
Regards,-Pavan

Tarek,

[Vishnu] As noted earlier in the thread, the topology-filter construct can be used in the specification of the filtered topology associated with a Network Resource Partition. This same construct, if supported by an implementation, may also be used in the specification of the topology filtering constraints for path computation. 

[Vishnu] Either works. It is an implementation/deployment choice and (imho) the toolkit should allow for both options to exist. 

Igor